/* function.h -- Copyright (c) 2004 Michael Pyne <michael.pyne@kdemail.net>
 * This software is licensed under the terms of the GNU General Public License,
 * v2 (or any later version).  This software is distributed WITH ABSOLUTELY NO
 * WARRANTY!.
 */

/* _FUNCTION_H was already taken, go figure. */
#ifndef _MPYNE_FUNCTION_H
#define _MPYNE_FUNCTION_H

#include <qstring.h>

typedef long double number_t;

namespace Abakus
{
    typedef enum { Degrees, Radians } TrigMode;
}

struct Function {
    QString name;
    number_t (*fn)(number_t);
    bool returnsTrig;
    bool needsTrig;
};

extern number_t parse_result;
extern int _last_parse_status_result;

void setTrigMode(Abakus::TrigMode mode);
Abakus::TrigMode trigMode();

const Function *function(const char *name);
number_t value(const char *name);
bool isValueSet(const char *name);
bool isFunction(const char *name);
void setValue(const char *name, const number_t value);

int last_parse_status_result(void);

number_t evaluateFunction(const Function *func, const number_t value);

/* Implemented in lexer.l due to prototype issues. */
number_t parseString(const char *str);

#endif
