#ifndef _ABAKUS_MAINWINDOW_H
#define _ABAKUS_MAINWINDOW_H

#include <kmainwindow.h>

class QVBox;
class QCheckBox;
class QRadioButton;
class KComboBox;
class KPopupMenu;
class KListBox;
class QBoxLayout;

// Main window class, handles events and layout and stuff
class MainWindow : public KMainWindow
{
    Q_OBJECT
    public:
    MainWindow();

    virtual bool event(QEvent *e);

    protected:
    virtual void contextMenuEvent(QContextMenuEvent *e);
    virtual bool eventFilter(QObject *o, QEvent *e);
    virtual bool queryExit();
    virtual void polish();

    private slots:
    void slotReturnPressed(const QString &text);
    void slotTextChanged(const QString &text);
    void slotEvaluate();
    void slotShowHistory(bool showHistory);
    void slotUpdateSize();
    void slotDegrees();
    void slotRadians();

    private:
    int getParenthesesLevel(const QString &str);
    void loadConfig();
    void saveConfig();

    QVBox *m_history;
    QCheckBox *m_showHistory;
    QRadioButton *m_degrees;
    QRadioButton *m_radians;
    KComboBox *m_edit;
    KPopupMenu *m_popup;
    KListBox *m_result;
    QString m_lastError;
    QBoxLayout *m_layout;
    QSize m_newSize, m_oldSize;

    bool m_insert;
};

#endif
